#!/bin/bash -x
CFLAGS="-Wall -I. -DNDEBUG"
LDFLAGS=""
echo "building objects:"
gcc $CFLAGS -c example.c  -o example.o    || exit
gcc $CFLAGS -c hello.c -o hello.o         || exit
nm example.o hello.o # print objets contents: provided and missing symbols
echo "building executable from objets:"
gcc $LDFLAGS example.o hello.o -o example || exit

echo "creating static library from objet"
ar rcs libhello.a hello.o                            || exit
echo "building executable using hello static library"
gcc $LDFLAGS example.o -L. -Wl,-Bstatic -lhello -Wl,-Bdynamic -o example_static_hello || exit
echo "building executable using all available static library"
gcc $LDFLAGS example.o -static -L. -lhello  -o example_static_all || exit

#creation dynamique
echo "building object for dynamic library"
gcc $CFLAGS -c -fPIC hello.c -o hello_fpic.o          || exit
echo "building dynamic library"
gcc $LDFLAGS -shared hello_fpic.o -o libhello.so      || exit
echo "build executable using dynamic library"
gcc $LDFLAGS example.o -L. -lhello -o example_dynamic || exit

echo "print dependencies on dynamic libraries:"
export LD_LIBRARY_PATH=.
ldd ./example_dynamic
ldd ./example_static_hello
ldd ./example_static_all

